/****************************************************

  LOOK AVR
mahdi mirzaei
    1389


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 16,000000 MHz

****************************************************/

#include <mega32.h>
#include <string.h>
#include <stdlib.h> 
#include <ctype.h>
#include <delay.h>
#include <stdio.h>
#include <lcd.h>
#include <i2c.h>
#include <ds1307.h>
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=7
   .equ __scl_bit=6
   .equ __lcd_port=0x1B ;PORTA
#endasm

#define  relay1          PORTD.1   
#define  relay2          PORTD.4  
#define  relay3          PORTD.5  
#define  light           PORTD.0
#define  light_LCD       PORTC.5
#define  alarm           PORTD.6
#define  conect_tel      PORTA.3
#define  data_in         PINC &0x0F

/************************************** **************************************************/
bit  S=0;
int  key_pressed=16,
     counter=10,
     cring=0,
     x=0,
     result,
     user,
     i,
     j,
     T0,
     T1,
     T2,
     T3,
     T4,
     T5;
char disp[6][13],
     pass_in[11]="",
     str_key_pressed[1],
     main_password_load[11]="",
     num_pass=0,
     tel_pas_ok=0,
     tel_pas_load[11]="",
     tel_pas_in[11]="",
     tel_key=14,
     tel_dtmf[1],
     result_tel,
     Brightcount=64,
     sw1=1,
     sw2=0,
     buffer[16];
unsigned char hour,
              mino,
              sec,
              syear,
              smonth,
              sday;
struct date
 {
  unsigned char day;
  unsigned char month;
  unsigned char year;
 }; 
struct date shmdate,mildate ;
flash unsigned char char10[8] = { 0x4, 0x4, 0x4, 0x4, 0x1F, 0xE, 0x4,0x0 },
                    char11[8] = { 0x4, 0xE, 0x1F, 0x4, 0x4, 0x4, 0x0,0x0 },
                    char12[8] = { 0x18, 0x1C, 0x1E, 0x1F, 0x1E, 0x1C, 0x18,0x0 },
                    char13[8] = { 0x0, 0x0, 0x1, 0x2, 0x14, 0x8, 0x0,0x0 },
                    shmtable[6][12]= {
                                      {11,10,10,9,9,9,8,9,9,10,11,9},
                                      {20,20,21,21,22,22,22,22,21,21,20,19},
                                      {11,10,10,9,9,9,8,9,9,10,11,10},
                                      {20,20,21,21,22,22,22,22,21,21,20,19},
                                      {12,11,11,10,10,10,9,10,10,11,12,10},
                                      {19,19,20,20,21,21,21,21,20,20,19,18}
                                     },
                    miltable[6][12]= {
                                       {20,19,19,19,20,20,21,21,21,21,20,20},
                                       {10,11,10,12,11,11,10,10,10,9,10,10},
                                       {19,18,20,20,21,21,22,22,22,22,21,21},
                                       {11,12,10,11,10,10,9,9,9,8,9,9},
                                       {20,19,20,20,21,21,22,22,22,22,21,21},
                                       {10,11,9,11,10,10,9,9,9,8,9,9}
                                      };

eeprom int relay_mod[4]={1,1,1,1},
           countring=3;
eeprom char main_pass[11]="0" ,
            user_1_pass[11]="1",
            user_2_pass[11]="2",
            user_3_pass[11]="3",
            pass_time_str[12]="NNNNNNNNN0N",
            phone_pass[11]="4";
eeprom unsigned char relay_user[6][3]={{1,1,1},{1,1,1},{1,1,1},{1,1,1},{1,1,1},{1,1,1}},
                     user_en[5][5]={{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0}};

/************************************** **************************************************/
void miltosham(unsigned char ym,unsigned char mm,unsigned char dm);
void shamtomil(unsigned char ys ,unsigned char ms,unsigned char ds);
void frest_page(void);
char refresh_key(char st,char x,char y);        
void clear(void);            
void meno(void);   
void Security_meno(void);
void Set_Password(void);
void User_Control (void);
void User_Control_active (void);
void User_Control_Time (void);
void User_Control_relay (void);
int chek_pass(void);
char user_c_t_ok(char use);
void compar_time();   
void compar_pass(void);
void pass_in_clean(void);
void key(void);
void change_pas();
void pass_time(void);
void clock(void);
void sound(unsigned int hz,int ms);
void tel_conect(void);
void relay(int r);
void Date_Time(void);
void sw_meno(char ud,char con);
void display_meno(char sw_1,char sw_2);
void Display(void);
void Brightness(void);
void TimeScreen(void);
void d_char(unsigned char flash *pc,unsigned char char_code);
void Relay_seting(void);
void Relay_set(void);
void Moment(void);
void Ring_Phone(void);

/**************************************************************************************************/

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
 {
  TCNT1H=0x0B;
  TCNT1L=0xDC;
  if(relay_mod[0]) if(relay1) if(T1>=relay_mod[0]) {T1=0; relay1=0;} else T1++;
  if(relay_mod[1]) if(relay2) if(T2>=relay_mod[1]) {T2=0; relay2=0;} else T2++;
  if(relay_mod[2]) if(relay3) if(T3>=relay_mod[2]) {T3=0; relay3=0;} else T3++;
  if(relay_mod[3]) if(light)  if(T4>=relay_mod[3]) {T4=0; light=0;}  else T4++;
  if(T0) T0--; 
  if(T5) T5--;       
 }
/**************************************************************************************************/
interrupt [EXT_INT0] void ext_int0_isr(void)
 {
  if (conect_tel==0)
    {
     if (light_LCD)
       {
        TCNT1H=0x0B;
        TCNT1L=0xDC;
        T0=counter;
       } 
     else if (!T0)
       {
        light_LCD=1;
        i=100;
        delay_ms(1200);
       }
    }
 }
/**************************************************************************************************/
interrupt [EXT_INT1] void ext_int1_isr(void)
 {
  if (user_c_t_ok(4)) 
    {
     if (!T5) cring=0;
     if(T5<5)
       {
        T5=8;
        cring++;
        if (cring>=countring)
          {
           light_LCD=0;
           conect_tel=1;
           cring=0;
           T5=0;
           T0=counter;
          }
       }
    }      
 }
/**************************************************************************************************/
void main(void)
 {
  PORTA=0x00;
  DDRA=0x08;
  PORTB=0xFE;
  DDRB=0x0F;
  PORTC=0x00;
  DDRC=0x20;
  PORTD=0x0C;
  DDRD=0xF3;
  TCCR0=0x00;
  TCNT0=0x00;
  OCR0=0x00;
  TCCR1A=0x00;
  TCCR1B=0x04;
  TCNT1H=0x0B;
  TCNT1L=0xDC;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x00;
  OCR1BH=0x00;
  OCR1BL=0x00;
  TIMSK=0x04;
  ASSR=0x00;
  TCCR2=0x6B;
  TCNT2=0x00;
  OCR2=64;
  GICR|=0xC0;
  MCUCR=0x0A;       //    
  MCUCSR=0x00;
  GIFR=0xC0;
  ACSR=0x80;
  SFIOR=0x00;
  rtc_init(0,1,0);
  lcd_init(16);
  d_char(char10,0);
  d_char(char11,1);
  d_char(char12,2);
  d_char(char13,3);
  conect_tel=0;
  light_LCD=1;
  if(!PINB.4 && !PINB.5)
    {
     for(i=0;i<600 && !PINB.4 && !PINB.5;i++)delay_ms(10);
     if(!PINB.4 && !PINB.5)
       {
        lcd_gotoxy(0,0);
        lcd_putsf("PASSWORD RESET..");
        for(i=0;i<16;i++)
          {
           lcd_gotoxy(i,1);
           lcd_putsf("\xff");
           lcd_gotoxy(i+1,1);
           lcd_putchar(2);
           delay_ms(200);
          }
        strcpy(pass_in,"9365994660");
        for(i=0;i<10;i++)                 
          {           
           main_pass[i]=pass_in[i];
           delay_ms(10);
          }
        main_pass[10]='/0';
        lcd_clear();
        lcd_gotoxy(7,0);
        lcd_putsf("OK");
        delay_ms(2000);
       }
    }
  while(!PINB.4 && !PINB.5);
  
  PORTB=0xF0; 
  lcd_clear();
  strcpy(buffer,"digital lock");
  for(i=0;i<12;i++)
    {
     lcd_gotoxy(i+2,0);
     lcd_putchar(buffer[i]);
     lcd_gotoxy(i+3,0);
     if(i<11)
       {
        lcd_putsf("\xff");
        sound(3000,100);
       }
     delay_ms(200);
    }     
  strcpy(buffer,"<mahdi  mirzaei>");
  for(i=0;i<16;i++)
    {
     lcd_gotoxy(i,1);
     lcd_putchar(buffer[i]);
     lcd_gotoxy(i+1,1);
     lcd_putsf("\xff");
     sound(3000,100);
     delay_ms(200);
    }      
  delay_ms(2000);        
  T0=0;
  #asm("sei")
  frest_page();
 } 
/**************************************************************************************************/
void miltosham(unsigned char ym,unsigned char mm,unsigned char dm)
 {
  unsigned char k,t1,t2; 
  k=ym%4;
  if(k==3) k=2;
  k*=2;
  t1=miltable[k][mm-1];
  t2=miltable[k+1][mm-1];
  if(mm<3 || (mm==3 && dm<=miltable[k][mm-1]))
    shmdate.year=ym+78;
  else
    shmdate.year=ym+79;
  if(dm<=t1)
    { 
     shmdate.day=dm+t2;
     shmdate.month=(mm+8)%12+1;
    }
  else 
    { 
     shmdate.day=dm-t1;
     shmdate.month=(mm+9)%12+1;
    }
 } 
/**************************************************************************************************/
void shamtomil(unsigned char ys ,unsigned char ms,unsigned char ds)
 {
  unsigned char k,t1,t2;
  k = ys%4;
  if(k==0)
    k=2;
  else 
    k=k+k;
  t1=shmtable[k - 2][ms-1];
  t2=shmtable[k-1][ms-1];
  if(ms<10 || (ms==10 && ds <= shmtable[k-2][ms-1]))
    mildate.year=ys-79;
  else 
    mildate.year=ys-78;
  if(ds <= t1)
    {
     mildate.day=ds+t2;
     mildate.month=(ms+1)%12+1;
    }
  else
    {
     mildate.day=ds-t1;
     mildate.month=(ms+2)%12+1;
    }
 } 
/**************************************************************************************************/
void frest_page(void)
 {
  pass_in_clean();
  while (1)
    {
     key();
     if(key_pressed==14)
       {
        lcd_clear();
        T0=0;
       }
     if(key_pressed==12)  
       {
        light_LCD=1;
        clear();
        lcd_gotoxy(0,0);
        lcd_putsf("Insert Password");          
       }
     if(key_pressed==15 && x>0) 
       {      
        compar_pass() ;
       }
     if(!T0) clock();           
    } 
 } 
/**************************************************************************************************/
 void key(void)
 {
   while (T0)
    {
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed>9) break;
     if(key_pressed>=0 && key_pressed<=9 && x<10)
       {
        itoa(key_pressed,str_key_pressed);
        strcat(pass_in,str_key_pressed);
        x++;
       }
     for(i=0;i<x;i++)   
       {
        lcd_gotoxy(i+2,1);
        lcd_putsf("*");
       }
    }
 }  
/**************************************************************************************************/
char refresh_key(char st,char x,char y)                                               
 {
   char KEY=16;
   while(KEY==16 && T0)
   {
    if(conect_tel) tel_conect();
    if (st)
      {
       lcd_gotoxy(x,y);
       _lcd_ready();
       _lcd_write_data(0x0F);
      }

    PORTB=0xFE;
    delay_ms(20);
    if(!PINB.4) KEY=1;
    if(!PINB.5) KEY=2;
    if(!PINB.6) KEY=3;
    if(!PINB.7) KEY=12;
    
    PORTB=0xFD;
    delay_ms(20);
    if(!PINB.4) KEY=4;
    if(!PINB.5) KEY=5;
    if(!PINB.6) KEY=6;
    if(!PINB.7) KEY=13;
    
    PORTB=0xFB;
    delay_ms(20);
    if(!PINB.4) KEY=7;
    if(!PINB.5) KEY=8;
    if(!PINB.6) KEY=9;
    if(!PINB.7) KEY=11;
    
    PORTB=0xF7;
    delay_ms(20);
    if(!PINB.4) KEY=14;
    if(!PINB.5) KEY=0;
    if(!PINB.6) KEY=15;
    if(!PINB.7) KEY=10;     
   }
   if(conect_tel) tel_conect();
   sound(3000,120);
   delay_ms(200);
   return KEY;
 }         
/**************************************************************************************************/
void relay(int r)
 {   
  if (r==1)
    {
     if(relay_user[user][0])  
       { 
        if (relay_mod[0]>0)
          {
           relay1=1;
           sound(2000,1000);
          }
        else  
          { 
           relay1=!relay1;
           if (relay1)
             {
              sound(2000,1000);
              delay_ms(100);
              sound(2000,3000);
             }
           else
             {
              sound(2000,1000);
              delay_ms(100);
              sound(2000,500);
              delay_ms(50);
              sound(2000,500);
             }
          }
       } 
      else
       { 
        lcd_clear();
        lcd_gotoxy(1,0);
        lcd_putsf("User is Limit");
        sound(2000,500);
        delay_ms(10);
        sound(1500,500);
        delay_ms(10);
        sound(1000,700);
        delay_ms(1000);
       }
    }   
  if (r==2)
    {
      if(relay_user[user][1])
       {
         if (relay_mod[1]>0)
          {
           relay2=1;
           sound(2000,1000);
           delay_ms(100);
           sound(2000,1000);
          }
        else
          { 
           relay2=!relay2;
           if (relay2)
             {
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(100);
              sound(2000,3000);
             } 
           else
             {
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(100);
              sound(2000,500);
              delay_ms(50);
              sound(2000,500);
             }
          }
       }
      else
       { 
        lcd_clear();
        lcd_gotoxy(1,0);
        lcd_putsf("User is Limit");
        sound(2000,500);
        delay_ms(10);
        sound(1500,500);
        delay_ms(10);
        sound(1000,700);
        delay_ms(1000);
       }       
    }     
  if (r==3)
    {
      if(relay_user[user][2])
       {
        if (relay_mod[2]>0)
          {
           relay3=1;
           sound(2000,1000);
           delay_ms(100);
           sound(2000,1000);
           delay_ms(100);
           sound(2000,1000);
          }
        else
          { 
           relay3=!relay3;
           if (relay3)
             {
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(100);
              sound(2000,3000);
             }
           else
             {
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(50);
              sound(2000,1000);
              delay_ms(100);
              sound(2000,500);
              delay_ms(50);
              sound(2000,500);
             }
          }
       }
      else
       { 
        lcd_clear();
        lcd_gotoxy(1,0);
        lcd_putsf("User is Limit");
        sound(2000,500);
        delay_ms(10);
        sound(1500,500);
        delay_ms(10);
        sound(1000,700);
        delay_ms(1000);
       }
    }               
 }
/**************************************************************************************************/
void tel_conect(void)
 {    
  #asm("sei")
  lcd_clear() ;
  lcd_putsf("Conect Telephon");
  lcd_gotoxy(1,1);
  lcd_putsf("please waite");
  delay_ms(1000);
  sound(1100,1000);
  GICR=0x00; 
  tel_pas_in[0]='\0';
  while(T0)
    {
     if (PINC.4)
       {
        TCNT1H=0x0B;
        TCNT1L=0xDC;
        T0=counter;
        tel_key=data_in;
        while(PINC.4) delay_ms(10);
        if(tel_pas_ok)
          {
           if (tel_key==11)
             {
              tel_key=14;
              tel_pas_ok=0;
              T0=0;        
             }
           user=4;
           if (tel_key==1) relay(1);
           if (tel_key==2) relay(2);
           if (tel_key==3) relay(3);
          }
        else
          {
           if (tel_key<=10)
             {
              if (tel_key==10) tel_key=0;
              itoa(tel_key,tel_dtmf);
              strcat(tel_pas_in,tel_dtmf); 
             }
           if (tel_key==11) T0=0;
           if (tel_key==12)
             {
              for(i=0;i<10;i++)     
                {           
                 tel_pas_load[i]=phone_pass[i];
                 delay_ms(10);
                } 
              result_tel=strcmp(tel_pas_in,tel_pas_load);
              if(result_tel)
                {
                 sound(2000,400);
                 delay_ms(50);
                 sound(2000,400);
                 delay_ms(50);
                 sound(2000,400);
                 T0=0;
                }
              else
                {
                 if (user_c_t_ok(4))
                   {
                    sound(2000,1500);
                    tel_pas_ok=1;
                    if(relay_mod[3]) light=1;
                   }
                  else
                   {
                    sound(2000,500);
                    delay_ms(50);
                    sound(2000,500);
                    delay_ms(50);
                    sound(2000,500);
                    delay_ms(50);
                    sound(2000,500);
                    T0=0;
                   }
                }
             }
          }
       }
    }
  delay_ms(800);
  sound(2000,1500);
  GICR=0xC0;     
  conect_tel=0;
 }
/**************************************************************************************************/
void sound(unsigned int hz,int ms) //hz=frequence(hz) , ms=time(ms)
 {
  unsigned int t;
  hz=50000/hz;
  hz*=10;
  for(;ms>0;ms--)
    {
     alarm=!alarm; 
     for(t=hz;t>0;t--) delay_us(1);
    }
  alarm=0; 
 }
/**************************************************************************************************/
void clear(void)
 {
  char lengh_pass_in;
  lengh_pass_in=strlen(pass_in);         
  pass_in[lengh_pass_in-1]=0;     
  lcd_clear();
  if(x>0) x--;
  for(i=0;i<x;i++)   
    {
     lcd_gotoxy(i+2,1);
     lcd_putsf("*");
    }
 }
/**************************************************************************************************/
void change_pas()
 {                                          
  char first_new_pass[11];
  lcd_clear();
  pass_in_clean();
  lcd_gotoxy(2,0);
  lcd_putsf("new Pass:");
  delay_ms(100);
  key();
  if(key_pressed==14) pass_in_clean();
  if(key_pressed==12) clear();
  if(key_pressed==15)   
    {                           
     x=0;                    
     strcat(pass_in,'\0');
     strcpy(first_new_pass,pass_in);
     pass_in_clean();
     lcd_clear();
     lcd_gotoxy(0,0);   
     lcd_putsf("confirm new Pass");
     delay_ms(100);
     key();
     if(key_pressed==14)
        pass_in_clean();
     if(key_pressed==12) clear();    
     if(key_pressed==15)
       {
        if(!strcmp(pass_in,first_new_pass))   
          {                                 
           lcd_clear();
           lcd_putsf("Password Changed");
           sound(2000,2000);
           delay_ms(50);                               
           if (user==0)
             {
              for(i=0;i<10;i++)                 
                {           
                 main_pass[i]=first_new_pass[i];
                 delay_ms(4);
                }
             }
           if (user==1)
             {
              for(i=0;i<10;i++)                 
                {           
                 user_1_pass[i]=first_new_pass[i];
                 delay_ms(4);
                }                                    
             }  
           if (user==2)
             {
              for(i=0;i<10;i++)                 
                {           
                 user_2_pass[i]=first_new_pass[i];
                 delay_ms(4);
                }                                    
             }  
           if (user==3)
             {
              for(i=0;i<10;i++)                 
                {           
                 user_3_pass[i]=first_new_pass[i];
                 delay_ms(4);
                }                                    
             }  
           if (user==4)
             {
              for(i=0;i<10;i++)                 
                {           
                 phone_pass[i]=first_new_pass[i];
                 delay_ms(4);
                }                                    
             }    
           x=0;
          } 
        else
          {
           lcd_clear();
           lcd_gotoxy(5,0);
           lcd_putsf("error");
           sound(3000,800);
           delay_ms(500);
           sound(3000,1200);
          }
       }
    }
 }
/**************************************************************************************************/
void Security_meno(void)
 {
  bit sm=0;
  while(T0)
    {   
     lcd_clear();
     lcd_gotoxy(2,0);
     lcd_putsf("Set Password");
     lcd_gotoxy(2,1);
     lcd_putsf("User Control");
     lcd_gotoxy(0,sm);
     lcd_putchar(2);
     delay_ms(20);            
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14)  break;
     if(key_pressed==10 || key_pressed==11 )sm=!sm;
     if(key_pressed==15)
       {
        if (sm) User_Control();
        else    Set_Password();
       }
    }
 }
/**************************************************************************************************/
void User_Control_Time (void)
 {
  char uct_x=1,uct_c[1];
  sprintf(buffer," %02u:%02u    %02u:%02u",user_en[user][1],user_en[user][2],user_en[user][3],user_en[user][4]);
  while(T0)
    {
     lcd_clear();
     lcd_gotoxy(0,0);
     lcd_putsf("On Time  OffTime");
     delay_ms(10);
     lcd_gotoxy(0,1);
     lcd_puts(buffer);
     delay_ms(30);
     key_pressed=refresh_key(1,uct_x,1);
     delay_ms(50);
     if (key_pressed==14)  break; 
     if(0<=key_pressed && key_pressed<=9)
       {
        itoa(key_pressed,uct_c);
        buffer[uct_x]=uct_c[0];
        uct_x++; 
        if (uct_x==3 || uct_x==12) uct_x++;
        if (uct_x==6) uct_x=10;
        if (uct_x==15) uct_x=1;
        if (buffer[1]>50) {buffer[1]=48; uct_x=1;}
        if (buffer[1]==50 && buffer[2]>51) {buffer[1]=48;buffer[2]=48;uct_x=2;}
        if (buffer[4]>53) {buffer[4]=48;uct_x=4;}
        if (buffer[10]>50) {buffer[10]=48; uct_x=10;}
        if (buffer[10]==50 && buffer[11]>51) {buffer[10]=48;buffer[11]=48; uct_x=11;}
        if (buffer[13]>53) {buffer[13]=48; uct_x=13;} 
       }                        
     if (key_pressed==15)
       {
        for(i=1,j=1;i<14;i++)
          {
           user_en[user][0]=2;
           if (i!=3 && i!=6 && i!=7 && i!=8 && i!=9 && i!=12 )
             {
              uct_c[0]=((buffer[i]-48) * 10) + (buffer[i+1]-48);
              user_en[user][j]=uct_c[0];
              j++;
              i++;
             }
          }
        key_pressed=16;
        break;
       }  
     if (key_pressed==13) 
       { 
        if (uct_x<14)
          {
           uct_x++;
           if (uct_x==3 || uct_x==12) uct_x++;
           if (uct_x==6) uct_x=10;
          }
        else uct_x=1; 
       }    
     if (key_pressed==12)
       {
        if (uct_x>1)
          {
           uct_x--;
           if (uct_x==3 || uct_x==12) uct_x--;
           if (uct_x==9) uct_x=5;
          }
        else uct_x=14;  
       }  
    }
 }
/**************************************************************************************************/
void User_Control_relay (void)
 {
  bit a=0;
  sw1=0;
  while(T0)
    {   
     lcd_clear();
     lcd_gotoxy(1,0);
     lcd_putsf("Relay1  Relay2");
     lcd_gotoxy(1,1);
     lcd_putsf("Relay3");
     if (relay_user[user][0]==1)  {lcd_gotoxy(7,0); lcd_putchar(3);}
     if (relay_user[user][1]==1)  {lcd_gotoxy(15,0); lcd_putchar(3);}
     if (relay_user[user][2]==1)  {lcd_gotoxy(7,1); lcd_putchar(3);}
     lcd_gotoxy(sw1,a);
     lcd_putchar(2);
     delay_ms(50);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14) {sw1=1; break;} 
     if(key_pressed==10 || key_pressed==11) a=!a;
     if(key_pressed==12 || key_pressed==13)
       {
        if(sw1==0)sw1=8;
          else sw1=0;
        a=0;
       }
     if(key_pressed==15)
       {
        if(a==0 && sw1==0)  relay_user[user][0]=!relay_user[user][0];
        if(a==0 && sw1==8)  relay_user[user][1]=!relay_user[user][1];
        if(a==1 && sw1==0)  relay_user[user][2]=!relay_user[user][2];
       } 
    }       
 }
/**************************************************************************************************/
void User_Control_active (void)
 {
  sw2=0;
  if (user_en[user][0]==1)
    sw1=1;
  else if (user_en[user][0]==0)
    sw1=2;
  else 
    sw1=3;
  while(T0)
    {   
     lcd_clear();
     lcd_gotoxy(15,0);
     lcd_putchar(1);
     lcd_gotoxy(15,1);
     lcd_putchar(0);
     delay_ms(20);            
     lcd_gotoxy(0,sw2);
     lcd_putchar(2);            
     if (sw1==1)
       {
        lcd_gotoxy(1,0);
        lcd_putsf("ON");
        delay_ms(20);
        lcd_gotoxy(1,1);
        lcd_putsf("OFF");
        if (user_en[user][0]==1) {lcd_gotoxy(14,0); lcd_putchar(3);}
        else if (user_en[user][0]==0) {lcd_gotoxy(14,1); lcd_putchar(3);}
       }
     else if(sw1==2)
       {
        lcd_gotoxy(1,0);
        lcd_putsf("OFF");
        delay_ms(20);
        lcd_gotoxy(1,1);
        lcd_putsf("Password when");
        if (user_en[user][0]==0) {lcd_gotoxy(14,0); lcd_putchar(3);}
        else if (user_en[user][0]==2) {lcd_gotoxy(14,1); lcd_putchar(3);}
       } 
     else if(sw1==3)
       {
        lcd_gotoxy(1,0);
        lcd_putsf("Password when");
        delay_ms(20);
        lcd_gotoxy(1,1);
        lcd_putsf("Access Relays");
        if (user_en[user][0]==2) {lcd_gotoxy(14,0); lcd_putchar(3);}
       }             
     else if(sw1==4)
       {
        lcd_gotoxy(1,0);
        lcd_putsf("Access Relays");
        delay_ms(20);
        lcd_gotoxy(1,1);
        lcd_putsf("ON");
        if (user_en[user][0]==1) {lcd_gotoxy(14,1); lcd_putchar(3);}
       }           
     delay_ms(50);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14) { sw2=0; sw1=1; break; }
     if(key_pressed==10) sw_meno(0,4);
     if(key_pressed==11) sw_meno(1,4);
     if(key_pressed==15)
       {
        if      ((sw2==0 && sw1==1) || (sw2==1 && sw1==4)) user_en[user][0]=1;
        else if ((sw2==0 && sw1==2) || (sw2==1 && sw1==1)) user_en[user][0]=0; 
        else if ((sw2==0 && sw1==3) || (sw2==1 && sw1==2)) User_Control_Time();
        else if ((sw2==0 && sw1==4) || (sw2==1 && sw1==3)) User_Control_relay();   
       }       
     
    }
 }
/**************************************************************************************************/
void User_Control (void)
 {
  strcpy(disp[0],"User_1");
  strcpy(disp[1],"User_2");
  strcpy(disp[2],"User_3");
  strcpy(disp[3],"User_Time");
  strcpy(disp[4],"User_Phone");
  sw2=0;
  sw1=1;
  while(T0)
    {   
     display_meno(sw1,5);
     lcd_gotoxy(0,sw2);
     lcd_putchar(2);
     delay_ms(50);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);       
     if(key_pressed==14)  break; 
     if(key_pressed==15)
       {
        if      ((sw1==5 && sw2==1) || (sw1==1 && sw2==0)) { user=0; User_Control_active(); }
        else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) { user=1; User_Control_active(); }
        else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) { user=2; User_Control_active(); }
        else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) { user=3; User_Control_active(); }
        else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) { user=4; User_Control_active(); }
       }
     if(key_pressed==10) sw_meno(0,5);
     if(key_pressed==11) sw_meno(1,5);
    }
 }
/**************************************************************************************************/
void Set_Password(void)
 {
  strcpy(disp[0],"Admin");
  strcpy(disp[1],"User-1");
  strcpy(disp[2],"User-2");
  strcpy(disp[3],"User-3");
  strcpy(disp[4],"User-Time");
  strcpy(disp[5],"User-Phone");
  while(T0)
    {   
     display_meno(sw1,6);
     lcd_gotoxy(0,sw2);
     lcd_putchar(2);
     delay_ms(50);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);       
     if(key_pressed==14)  break;
     if(key_pressed==15)
       {
        if      ((sw1==6 && sw2==1) || (sw1==1 && sw2==0)) { user=0; change_pas(); }
        else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) { user=1; change_pas(); }
        else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) { user=2; change_pas(); }
        else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) { user=3; change_pas(); }
        else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) pass_time(); 
        else if ((sw1==5 && sw2==1) || (sw1==6 && sw2==0)) { user=4; change_pas(); }
       }
     if(key_pressed==10) sw_meno(0,6);
     if(key_pressed==11) sw_meno(1,6);
    }
 }
/**************************************************************************************************/
void pass_time(void)
 {
  char str_pass[16],k2=0,k4[2];
  lcd_clear();
  lcd_gotoxy(0,0);
  lcd_putsf("Y/MM/DD-HH:MM:SS");  
  for (i=0,j=0;i<16;i++)
    {
     if (i!=1 && i!=4 && i!=7 && i!=10 && i!=13)
       {
        str_pass[i]=pass_time_str[j];
        j++;
       }
     else
       str_pass[i]=' ';
    } 
  while(T0)
    {
     lcd_gotoxy(0,1);
     lcd_puts(str_pass);
     delay_ms(30);
     key_pressed=refresh_key(1,k2,1);
     delay_ms(50);
     if (key_pressed==14)  break; 
     if(0<=key_pressed && key_pressed<=9)
       {
        itoa(key_pressed,k4);
        for (i=0;i<16;i++) if (str_pass[i]==toascii(k4[0])) break;
        if (i) str_pass[i]='N';
        str_pass[k2]=k4[0];
       }                        
     if (key_pressed==15)
       {
        for(i=0,j=0;i<16;i++)
          {
           if (i!=1 && i!=4 && i!=7 && i!=10 && i!=13)
             {
              pass_time_str[j]=str_pass[i];
              j++;
             }
          }
        key_pressed=16; 
        break; 
       }  
     if (key_pressed==13) 
       if (k2<15)
          {
           k2++;
           if (k2==1 || k2==4 || k2==7 || k2==10 || k2==13)
             k2++;
          } 
     if (key_pressed==12)
       if (k2)
          {
           k2--;
           if (k2==1 || k2==4 || k2==7 || k2==10 || k2==13)
             k2--;
          }
     if (key_pressed==10)
       str_pass[k2]='N';
    }
 } 
/**************************************************************************************************/ 
void compar_time() 
 { 
  char str[2],str_time[11],str_pass[11]="0000000000";
  int y,cc=0;
  for(i=0;i<11;i++) str_time[i]='\0'; 
  syear=shmdate.year;
  smonth=shmdate.month;
  sday=shmdate.day;
  y=syear%10;
  i=0;
  itoa(y,str);
  str_time[0]=str[0];
  if (smonth<10) str_time[1]='0'; 
  itoa(smonth,str);
  strcat(str_time,str);
  if (sday<10) str_time[3]='0';
  itoa(sday,str);
  strcat(str_time,str);
  if (hour<10) str_time[5]='0';
  itoa(hour,str);
  strcat(str_time,str);
  if (mino<10) str_time[7]='0';
  itoa(mino,str);
  strcat(str_time,str);
  if (sec<10) str_time[9]='0';
  itoa(sec,str);
  strcat(str_time,str);  
  for (i=0;i<11;i++)
     if (pass_time_str[i]!='N')
        {
         j=pass_time_str[i]-48;
         str_pass[j]=str_time[i];
         if (j>cc) cc=j;
        }               
  str_pass[cc+1]='\0';  
  strcpy(main_password_load,str_pass);
 }
/**************************************************************************************************/
int chek_pass(void)
 {
  for(i=0;i<10;i++)
    {
     main_password_load[i]=main_pass[i];
     delay_ms(4);
    }
  if (strcmp(pass_in,main_password_load)==0)
    {
     result=1;
     goto end;
    }
  for(i=0;i<10;i++)
    {
     main_password_load[i]=user_1_pass[i];
     delay_ms(4);
    }
  if (strcmp(pass_in,main_password_load)==0)
    {
     result=4;
     goto end;
    }
  for(i=0;i<10;i++)
    {
     main_password_load[i]=user_2_pass[i];
     delay_ms(4);
    }
  if (strcmp(pass_in,main_password_load)==0)
    {
     result=5;
     goto end;
    }
  for(i=0;i<10;i++)
    {
     main_password_load[i]=user_3_pass[i];
     delay_ms(4);
    }
  if (strcmp(pass_in,main_password_load)==0)
    {
     result=6;
     goto end;
    }
  compar_time();
  if (strcmp(pass_in,main_password_load)==0)
    {
     result=3;
     goto end;
    }
  result=0;
  end:
  return result;
 }
/**************************************************************************************************/ 
char user_c_t_ok(char use)
 {
  unsigned char user_et[5];
  int time_on,time_off,time_in;
  for (i=0;i<5;i++) user_et[i]=user_en[use][i];
  if (user_et[0]==0) return 0;
  else if (user_et[0]==1) return 1;
  else if (user_et[0]==2)
    {
     time_on=user_et[1]*100+user_et[2];
     time_off=user_et[3]*100+user_et[4];
     time_in= hour*100+mino;
     if (time_on>time_off)
       {
        if (time_in>=time_on || time_in<time_off)
          return 1;
        else
          return 0;  
       }
     else if (time_on<time_off)
       {
        if (time_in>=time_on && time_in<time_off)
          return 1;
        else
          return 0;
       }
     else  return 0;
    }
 }
/**************************************************************************************************/
void compar_pass(void)
 {
  result=chek_pass();
  if(result)
    {
     lcd_clear();
     if (result==1)
       {
        lcd_putsf("OK  User Admin");
        sw1=5;
        goto home;
       } 
     if (result==4)
       {
        if (user_c_t_ok(0))
          {
           lcd_putsf("OK   User 1");
           sw1=0;
           goto home;
          } 
       }
     if (result==5) 
       {
        if (user_c_t_ok(1))
          {
           lcd_putsf("OK   User 2");
           sw1=1;
           goto home;
          }
       }
     if (result==6) 
       {
        if (user_c_t_ok(2))
          {
           lcd_putsf("OK   User 3");
           sw1=2;
           goto home;
          }
       }
     if (result==3) 
       {
        if (user_c_t_ok(3)) 
          {
           lcd_putsf("OK Based on Time");
           sw1=3;
           goto home;
          } 
       }
     lcd_clear();
     lcd_putsf(" This password");
     lcd_gotoxy(0,1);
     lcd_putsf("is a time limit");
     sound(2000,500);
     delay_ms(10);
     sound(1500,500);
     delay_ms(10);
     sound(1000,700);
     delay_ms(200);
     goto end;
     
     home:
     if(relay_mod[3]) {T4=0; light=1;}
     user=sw1;
     lcd_gotoxy(2,1);
     lcd_putsf("1 , 2 , 3");
     key_pressed=refresh_key(0,0,0);
     if(key_pressed==14)  goto endl;
     if(key_pressed==13)
       {
        if (result==1)
           meno();
        if(result==4 || result==5 || result==6)
          {
           user=result-3;
           change_pas();
          }
        goto endl;      
       }    
     if(key_pressed==1)
       {
        lcd_clear();
        lcd_gotoxy(2,0);
        lcd_putsf("Relay 1 ON");
        relay(1);
        delay_ms(500);
       } 
     if(key_pressed==2)
       {
        lcd_clear();
        lcd_gotoxy(2,0);
        lcd_putsf("Relay 2 ON");
        relay(2);
        delay_ms(500);
       }                           
     if(key_pressed==3)
       {
        lcd_clear();
        lcd_gotoxy(2,0);
        lcd_putsf("Relay 3 ON");
        relay(3);
        delay_ms(500);
       } 
     end:  
     num_pass=0;
    }
  else
    {
     lcd_clear();
     lcd_putsf("Error password");
     sound(3000,700);
     delay_ms(100);
     sound(3000,1000);
     num_pass++;
     if(num_pass>=4)
       {
        delay_ms(500);
        sound(3000,3500);
        GICR=0x80;
        T0=180;
        lcd_clear();
        lcd_putsf("warning");
        delay_ms(20);
        lcd_gotoxy(0,1);
        lcd_putsf("Keypad disabled");
        while(T0) delay_ms(1000);
        GICR=0xC0;
        num_pass=0;
       }
    }
  x=0;
  T0=2;
  if(refresh_key(0,0,0)<16); 
  endl:
  T0=0;
 }
/**************************************************************************************************/   
void Date_Time(void)
 {
  unsigned char hour1,mino1,sec1,year1,month1,day1;
  char tim[9],dat[9],car[2];
  i=4;
  j=0;
  rtc_get_time(&hour1,&mino1,&sec1);
  rtc_get_date(&day1,&month1,&year1);
  if(!year1) year1=10;
  miltosham(year1,month1,day1);
  sprintf(tim,"%02u:%02u:%02u",hour1,mino1,sec1);
  sprintf(dat,"%02u/%02u/%02u",shmdate.year,shmdate.month,shmdate.day);
  while(T0) 
    {
     lcd_clear();
     delay_ms(50);
     lcd_gotoxy(4,0);
     lcd_puts(tim);
     lcd_gotoxy(4,1);
     lcd_puts(dat);
     key_pressed=refresh_key(1,i,j);
     delay_ms(50);
     if (key_pressed==14)  break;      
     if(0<=key_pressed && key_pressed<=9)
       {
        itoa(key_pressed,car);
        if(j)
          {
           if(i==7)
             {
              if(key_pressed>1) goto cancel;
              if(key_pressed==0 && dat[4]<55 && dat[6]==51 && dat[7]==49) dat[7]=48;
             }  
           if(i==8)
             {
              if(dat[3]>48)
                 if(key_pressed>2) goto cancel;
              if(key_pressed>6 && dat[3]<49 && dat[6]==51 && dat[7]==49) dat[7]=48;
             }   
           if(i==10)
             {
              if(key_pressed<4)
                { 
                 if(key_pressed>2)
                   {
                    if(dat[3]<49 && dat[4]<55 && dat[7]>49) dat[7]=49;
                    if(dat[3]<49 && dat[4]>54 && dat[7]>48) dat[7]=48;
                    if(dat[3]>48 && dat[7]>48) dat[7]=48;
                   }
                 }  
              else
                 goto cancel;
             }    
           if(i==11)
             {
              if(dat[6]==51)
                {
                 if(dat[3]<49 && dat[4]<55)
                    if(key_pressed>1) goto cancel;
                 else
                    if(key_pressed>0) goto cancel;
                }   
             }       
           dat[i-4]=car[0];
          }
        else
          {
           if(i==4)
             { 
              if(key_pressed>2) goto cancel;
              if(key_pressed>1 && tim[1]>51) tim[1]=48;
             } 
           if(i==5)
              if(tim[0]>49)
                 if(key_pressed>3) goto cancel;
           if(i==7 || i==10)
              if(key_pressed>5) goto cancel;
           tim[i-4]=car[0]; 
          }
        i++;
        if(i==6 || i==9)i++;
        if(i>11)
          {
           i=4;
           j=!j;
          }
        cancel:  
       }
     else if (key_pressed==13)
       {
        i++;
        if(i==6 || i==9)i++;
        if(i>11)i=4;
       }
     else if (key_pressed==12)
       {
        i--;
        if(i==6 || i==9)i--;
        if(i<4)i=11;
       }
     else if (key_pressed==10 || key_pressed==11) j=!j;
     else if (key_pressed==15)   
       {
        for(i=0;i<8;i++)
          {
           tim[i]-=48;
           dat[i]-=48;
          } 
        hour1=tim[0]*10+tim[1];
        mino1=tim[3]*10+tim[4];
        sec1=tim[6]*10+tim[7];
        year1=dat[0]*10+dat[1];
        month1=dat[3]*10+dat[4];
        day1=dat[6]*10+dat[7];
        shamtomil(year1,month1,day1);
        rtc_set_time(hour1,mino1,sec1);
        rtc_set_date(mildate.day,mildate.month,mildate.year);
        break; 
       } 
    }
 }
/**************************************************************************************************/  
void clock(void)
 {
  PORTB=0xF0;
  i=20;   
  S=0;
  while (!T0)
    {
     rtc_get_time(&hour,&mino,&sec);
     rtc_get_date(&sday,&smonth,&syear);
     miltosham(syear,smonth,sday);
     lcd_clear();
     lcd_gotoxy(4,0);
     if (S) {sprintf(buffer,"%02u:%02u:%02u",hour,mino,sec); S=0; }
     else   {sprintf(buffer,"%02u %02u %02u",hour,mino,sec); S=1; }
     lcd_puts(buffer);
     lcd_gotoxy(4,1);
     sprintf(buffer,"%02u/%02u/%02u",shmdate.year,shmdate.month,shmdate.day);
     lcd_puts(buffer);
     delay_ms(495);
     if(i>1)i--;
     else light_LCD=0;
    }          
  S=0;
  if(conect_tel) tel_conect();
  pass_in_clean();
  light_LCD=1;
  lcd_clear();
  lcd_putsf("Insert Password");
 }
/**************************************************************************************************/
void pass_in_clean(void)
 {
  char j,b;
  b=strlen(pass_in);
  for(j=0;j<b;j++)pass_in[j]='\0';
  x=0;
 }   
/**************************************************************************************************/   
void display_meno(char sw_1,char sw_2)
 {
  if (sw_1<sw_2)
    {
     sw_2=sw_1;
     sw_1=sw_1-1;
    }
  else
    {
     sw_2=0;
     sw_1=sw_1-1;
    } 
  lcd_clear();
  lcd_gotoxy(2,0);
  lcd_puts(disp[sw_1]);
  lcd_gotoxy(2,1);
  lcd_puts(disp[sw_2]);
  lcd_gotoxy(15,0);
  lcd_putchar(1);
  delay_ms(20);
  lcd_gotoxy(15,1);
  lcd_putchar(0);     
 }
/**************************************************************************************************/
void sw_meno(char ud,char con)
 {
  if(ud)
    {
     if (sw2) sw2=0;
     else if (!sw2) sw1--;
     if (sw1<1) sw1=con;
    } 
  else
    {
     if (!sw2) sw2=1;
     else if (sw2) sw1++;
     if (sw1>con) sw1=1;
    }
 }
/**************************************************************************************************/
void meno(void)
 {
  sw1=1;
  S=0;
  while(T0)
    {   
     if(!S)
       {
        strcpy(disp[0],"Security");
        strcpy(disp[1],"Date&Time");
        strcpy(disp[2],"Display");
        strcpy(disp[3],"Relay mod");
        strcpy(disp[4],"Ring Phone");
        sw1=1;
        sw2=0;
        S=1;
       }
     display_meno(sw1,5);
     lcd_gotoxy(0,sw2);
     lcd_putchar(2);
     delay_ms(50);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);       
     if(key_pressed==14)  break;
     if(key_pressed==15)
       {
        if      ((sw1==5 && sw2==1) || (sw1==1 && sw2==0)) {Security_meno(); S=0;} 
        else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) {Date_Time();     S=0;} 
        else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) {Display();       S=0;} 
        else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) {Relay_seting();  S=0;}
        else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) {Ring_Phone();    S=0;} 
       }
     if(key_pressed==10) sw_meno(0,5);
     if(key_pressed==11) sw_meno(1,5);
    }
 }
/**************************************************************************************************/
void Ring_Phone(void)
 {
  while(T0)
    {
     lcd_clear();
     lcd_gotoxy(0,0);
     lcd_putsf("Ring Phone:");
     lcd_gotoxy(11,0);
     itoa(countring,buffer);
     lcd_puts(buffer);
     key_pressed=refresh_key(1,11,0);
     delay_ms(50);
     if(key_pressed==14 || key_pressed==15)  break; 
     if(0<key_pressed && key_pressed<=9)
       {
        countring=key_pressed;
        delay_ms(100);
       }
    }
 }
/**************************************************************************************************/
void Moment(void)
 {
  char k[1];
  sw1=11;
  sprintf(buffer,"%3d",relay_mod[j]);
  for(i=0;i<3;i++) if(buffer[i]==32) buffer[i]=48;
  i=0;  
  while(T0)
    {
     lcd_clear();
     lcd_gotoxy(0,0);
     lcd_putsf("Moment for:");
     lcd_gotoxy(11,0);
     lcd_puts(buffer);
     key_pressed=refresh_key(1,sw1,0);
     delay_ms(50);
     if (key_pressed==14) break;
     if(0<=key_pressed && key_pressed<=9)
        {
         itoa(key_pressed,k);
         buffer[i]=k[0];
         sw1++;
         i++; 
         if (sw1==14) {sw1=11; i=0;}
        }                        
     if (key_pressed==15)
        {
         relay_mod[j]=((buffer[0]-48)*100)+((buffer[1]-48)*10)+(buffer[2]-48);
         break;
        }  
    }
  sw2=0;                      
  sw1=1;  
 }
/**************************************************************************************************/ 
void Relay_set()
 {
  bit rs=0;
  while(T0)
    {   
     lcd_clear();
     lcd_gotoxy(2,0);
     lcd_putsf("Moment");   //                      
     lcd_gotoxy(2,1);
     lcd_putsf("Permanent"); // 
     lcd_gotoxy(0,rs);
     lcd_putchar(2);
     if (relay_mod[j]) {lcd_gotoxy(13,0); lcd_putchar(3);}
     else              {lcd_gotoxy(13,1); lcd_putchar(3);}
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14)  break; 
     if(key_pressed==10 || key_pressed==11 )  rs=!rs;
     if(key_pressed==15)
       {
        if (rs) relay_mod[j]=0;
        else Moment();
       }
    } 
 }
/**************************************************************************************************/
void Relay_seting(void)
 {
  strcpy(disp[0],"Relay 1");
  strcpy(disp[1],"Relay 2");
  strcpy(disp[2],"Relay 3");
  strcpy(disp[3],"Relay 0*");
  sw2=0;                      
  sw1=1;
  while(T0)
    {   
     display_meno(sw1,4);
     lcd_gotoxy(0,sw2);
     lcd_putchar(2);            
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14)  break; 
     if(key_pressed==10) sw_meno(0,4);
     if(key_pressed==11) sw_meno(1,4);
     if(key_pressed==15)
       {
        if      ((sw2==0 && sw1==1) || (sw2==1 && sw1==4)){ j=0; Relay_set(); }
        else if ((sw2==0 && sw1==2) || (sw2==1 && sw1==1)){ j=1; Relay_set(); }
        else if ((sw2==0 && sw1==3) || (sw2==1 && sw1==2)){ j=2; Relay_set(); }
        else if ((sw2==0 && sw1==4) || (sw2==1 && sw1==3)){ j=3; Moment(); }
       }       
    }
 }
/**************************************************************************************************/   
void Display(void)
 {
  bit sc=0;
  while(T0)
    {   
     lcd_clear();
     lcd_gotoxy(2,0);
     lcd_putsf("Brightness");
     lcd_gotoxy(2,1);
     lcd_putsf("TimeScreen");
     lcd_gotoxy(0,sc);
     lcd_putchar(2);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14)  break;
     if(key_pressed==10 || key_pressed==11 ) sc=!sc;
     if(key_pressed==15)
       {
        if (sc) TimeScreen();
        else Brightness();
       }
    }
 }
/**************************************************************************************************/
 void Brightness(void)
 {
  while(T0)
    {
     lcd_clear();
     lcd_gotoxy(14,0);
     sprintf(buffer,"\x7f");
     lcd_puts(buffer);
     lcd_gotoxy(15,0);
     sprintf(buffer,"\x7e");
     lcd_puts(buffer);
     lcd_gotoxy(0,0);
     lcd_putsf("Brightness:");
     for (i=0;i<=Brightcount/8;i++)
       {
        lcd_gotoxy(i,1);
        lcd_putsf("\xff");
       }
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==15 || key_pressed==14)   break;
     if(key_pressed==12) if(Brightcount>7) Brightcount-=8; 
     if(key_pressed==13)  if(Brightcount<121) Brightcount+=8;
     OCR2=128-Brightcount;
    }
 }
/**************************************************************************************************/
 void TimeScreen(void)
 {
  int counter_1;
  counter_1=counter;
  while(T0)
    {
     lcd_clear();
     lcd_gotoxy(0,0);
     lcd_putsf("TimeScreen:");
     lcd_gotoxy(15,0);
     lcd_putchar(1);
     lcd_gotoxy(15,1);
     lcd_putchar(0);
     lcd_gotoxy(11,0);
     sprintf(buffer,"%3u",counter_1);
     lcd_puts(buffer);
     key_pressed=refresh_key(0,0,0);
     delay_ms(50);
     if(key_pressed==14) break;
     if(key_pressed==10) {counter_1--; if (counter_1==0) counter_1=60;}
     else if(key_pressed==11) {counter_1++; if (counter_1==60) counter_1=1;}
     else if(key_pressed==15) {counter=counter_1; break;}
    }
 }
/**************************************************************************************************/
 void d_char(unsigned char flash *pc,unsigned char char_code)
 {
  unsigned char a;
  a=(char_code<<3) | 0x40;
  for (i=0;i<8;i++) lcd_write_byte(a++,*pc++); 
 }

